
Version 0.41: 2025-04-07

	- internal:
	  replaced non-API C functions by equivalent API functions
	  replaced macros from deprecated header file "Rdefines.h"


Version 0.40: 2024-10-03

	- updated DESCRIPTION


Version 0.39: 2024-09-19

	- dau.new():
	  fixed issue with constant probability vector

	- internal:
	  moved directory with maintainance scripts out of package directory
	  fixed defunct declarations


Version 0.38.0: 2023-01-17

	- pinv.new():
	  fixed issue with PDFs that almost vanish at the boundary of
	  the domain

	- internal:
	  replaced deprecated C function sprintf() by snprintf()


Version 0.37.0: 2022-10-18

	- internal:
	  fixed compiler warning
	  

Version 0.36.0: 2022-05-05

	- internal:
	  fixed issue in Rd file
	  fixed deprecated usage of class() in if statements


Version 0.35.0: 2021-10-22

	- internal:
	  fixed issues with autoconf-2.71


Version 0.34.0: 2021-08-11

	- pinv.new():
	  fixed issues with PDFs which are constant on subdomains

	- uq():
	  now works with objects created by mixt.new(..., inversion=TRUE)


Version 0.33.0: 2020-11-01

	- internal:
	  fixed unPTROTECTed variables in C code


Version 0.32.0: 2020-10-28

        - updated reference for method HITRO.


Version 0.31.0: 2020-10-27

	- internal:
	  fixed unPTROTECTed variables in C code


Version 0.30.0: 2020-02-12

	- disabled all output tests on CRAN:
	  The results of C call Rprintf() differ on different OS.


Version 0.29.0: 2020-02-08

	- up() and uq():
	  some error messages give more useful informations
	  
	- internal:
	  reorganized some checks
	  
	  removed checks for unuran.details()
	  which print too many digits and are thus
	  too sensitive against round-off errors
	  on different platforms


Version 0.28.0: 2020-02-03

	- internal:
	  removed deprecated statement from configure.ac


Version 0.27.0: 2019-03-14

	- fixed unPTROTECTed variable in C code
	

Version 0.26.0: 2019-03-13

	- new function Runuran.options()

	- internal:

	  make CRAN - 'rchk' happy.

	  functions ud(), up() and unuran.is.inversion() are a bit faster.

	  use package 'testthat' for new tests.

	  use package 'roxygen2' for creating new help pages.

	  new function .Runuran.stop() for creating error messages
	  with correct user level function names.


Version 0.25.0: 2018-03-23

	- new functions arou.new()

	- new functions tabl.new()


Version 0.24.0: 2017-10-25

	- export some C functions

	- register native routines

	- fixed unprotected variables in C code


Version 0.23.0: 2015-08-18

	- fixed problem with methods "initialize" and "plot"


Version 0.22.0: 2015-07-17

 	- explicitly import functions from standard packages


Version 0.21.0: 2014-08-28

	- new method use.aux.urng() for using a second auxiliary
	  URNG in Runuran objects that are based on the
	  acceptence-rejection method.
	  This makes this kind of genenator suitable for 
	  correlation induction.

	- new function set.aux.seed() for seeding the auxiliary URNG.

	- moved vignettes from directory inst/doc/ into 
	  directory vignettes/.

	- fixed some typos

	- internal:
	  added directory src/scripts with scripts for updating
	  documentation.


Version 0.20.0: 2012-09-10

	- Handle empty Runuran update

 	- internal: renamed directory with inputs for vignette


Version 0.19.0: 2012-01-31

	- pinv.new():
	  setup is now numerically more robust.

	- ud():
	  added argument 'islog' (with default FALSE).
	  When TRUE, the log-density is returned (if available).

	- new function udmeixner() for Meixner distribution.

	- new function udvg() for Variance Gamma distribution.

	- new function udgiga():
	  provides an alternative parametrization for the Generalized
	  Inverse Gaussian (GIG) distribution.

	- udghyp(): implementation of PDF is numerically more stable.

	- unuran.details(...,debug=TRUE):
	  the array of precomputed constants is returned for
	  methods CSTD and DSTD.


Version 0.18.0: 2011-05-19

	- unuran.discr.new(): new argument 'cdf' for adding
	  CDF to user-defined discrete distribution.

	- unuran.details(return.list=TRUE,...): 
	  returned list contains the new field "distr.class" that
	  contains the type (class) of distribution:
	  "cont", "discr" or "cmv". 

	- added more checks in various functions that verify given
	  arguments.

	- removed some obselete lines of C code.


Version 0.17.0: 2011-01-26

	- new function unuran.is.inversion():
	  test whether the generator object implements an inversion
	  method.

	- internal: 

	  * S4 class "unuran" has new slot "inversion" for
            storing information about type of generation method


Version 0.16.0: 2010-10-25

	- fixed Rd files

	- bug fixes


Version 0.15.0: 2010-08-06

	- new function up() for computing distribution function
	  for a unuran object.

	- ud(): first argument has been renamed from 'distr' to 'obj'.
	  argument 'obj' can also be a generator object.

	- pinv.new(): when no 'center' is provided by the user, or
	  when the PDF vanishes or is not finite for the given 'center',
	  then the method tries to "guess" an appropriate
	  point for the 'center'.

	- special functions (like gamma function) are now taken from
	  the Rmath library.


Version 0.14.0: 2010-04-29

	- new argument 'smooth' for function pinv.new().

	- method PINV (pinv.new and pinvd.new) is now more robust 
	  for distributions with "rough" PDFs (e.g. those created by
	  spline interpolation).

	- new function unuran.verify.hat():
	  Check hat and squeeze of a method that is based on the
	  rejection method.


Version 0.13.0: 2010-02-09

	- added new function mixt.new() for creating a generator for a
	  finite mixture of (continuous/discrete) univariate distributions.


Version 0.12.0: 2010-01-04
	
	- unuran.details() now has two new arguments 'show' and
	  'return.list'. If 'return.list=TRUE' then the function returns
	  a list that contains some of the data.

	- some improved error messages

	- fixed bug that caused unuran.details() to hang


Version 0.11.0: 2009-11-17

	- method 'r' is defunct. 
	  Please use (the identical but faster function) 'ur'.

	- new functions for creating S4 distributions objects for
	  special distributions:        

	  continuous distributions:
	    udbeta        ... beta
	    udcauchy      ... Cauchy
	    udchi         ... chi
	    udchisq       ... chi-squared
	    udexp         ... exponential
	    udf           ... F
	    udfrechet     ... Frechet
	    udgamma       ... gamma
	    udghyp        ... generalized hyperbolic
	    udgig         ... generalized inverse Gaussian
	    udgumbel      ... Gumbel
	    udhyperbolic  ... hyperbolic
	    udig          ... inverse Gaussian
	    udlaplace     ... Laplace
	    udlnorm       ... log normal
	    udlogis       ... logistic
	    udlomax       ... lomax
	    udnorm        ... normal
	    udpareto      ... Pareto
	    udpowerexp    ... powerexponential
	    udrayleigh    ... Rayleigh
	    udslash       ... Slash
	    udt           ... Student's t
	    udweibull     ... Weibull

 	  discrete distributions:
	    udbinom       ... binomial
	    udgeom        ... geometric
	    udhyper       ... hypergeometric
	    udlogarithmic ... logarithmic
	    udnbinom      ... negative binomial
	    udpois        ... Poisson

	- deprecated functions are defunct.
	  Please replace 

 	    uqhinv         by uq

 	    unuran.cmv     by unuran.cmv.new
	    unuran.cont    by unuran.cont.new
	    unuran.discr   by unuran.discr.new

 	    urhitro(n,...) by ur(hitro.new(...),n)
 	    urtdr(n,...)   by ur(tdr.new(...),n)


Version 0.10.1: 2009-08-06

	- bugfix: pinv.new() now also works for R versions compiled with 
	SunStudio compiler.


Version 0.10: 2009-06-22

	- new function 'unuran.packed' for packing 'unuran' objects.
	  When packed, all information are stored as R lists and allows
	  handling of 'unuran' objects just as ordinary R objects, in
	  particular they can then saved and restored in future R sessions,
	  and they can be copied to other nodes in parallel computing.

	- uq() now also supports method 'DGT' (for discrete distributions).


Version 0.9: 2009-02-26

	- IMPORTANT:

	  Paramters 'lb' and 'ub' (lower and upper bound of domain)
	  do not have default values any more and are obligatory in
	  all functions with these arguments. Thus thee following
	  functions have been changed:

	   o Continuous distributions:
	     	unuran.cont.new
	        ars.new
	        itdr.new
	        pinv.new
	        srou.new
	        tdr.new
	     If R stops when calling these functions with the error
	     message "domain ('lb','ub') missing", then one has to add
	     the formerly defaults "lb=-Inf" and/or "ub=Inf" for the
	     missing arguments.

	   o Discrete distributions:
	        unuran.discr.new
	        dari.new
	     If R stops when calling these functions with the error
	     message "domain ('lb','ub') missing", then one has to add
	     the formerly defaults "lb=0" and/or "ub=Inf" for the
	     missing arguments.

	  We observed a possible pitfall with the former interface.
	  When a user wanted to draw a sample from a distribution with
	  positive domain but forgot to set "lb=0" then it was
	  possible that the generator (silently!) did not work as
	  expected and caused invalid simulation results.
	  Forcing to set the domain reduces this risk.
	  Thus we decided to stay on the safe side.

	  We appologize for this inconvenience.

	- fixed syntax errors and inconsistent formating in Rd files.


Version 0.8: 2008-11-26

	- reorganized functions into three groups:

	  * Runuran-Distribution:
	    easy-to-use sampling algorithms for particular
	    distributions.

	  * Runuran-Universal:
	    interface to a carefully selected collection of UNU.RAN
	    methods with their most important variants.

	  * Runuran-Advanced:
	    wrapper to the UNU.RAN string API.

	- improved documentation,
	  added vignette

	- new function uq() for computing quantiles apprimately.

	- new functions for directly creating generator objects
	  for selected UNU.RAN methods:
	    ars.new()
	        dari.new()
	    dau.new()
	    dgt.new()
	    hitro.new()
	    itdr.new()
	    pinv.new()
	    srou.new()
	    tdr.new()
	    vnrou.new()

	- new functions for creating UNU.RAN distribution 
	  objects: 

	    unuran.cmv.new(...)    replaces  unuran.cmv()
	    unuran.cont.new(...)   replaces  unuran.cont()
	    unuran.discr.new(...)  replaces  unuran.discr()

	  Remark: The default for argument 'islog' has been changed to 
	  'islog=FALSE'.

	- deprecated functions:
	     uqhinv()
	     urdau()
	     urdgt()	
	     urhitro()
	     urtdr()

	- contains UNU.RAN version 1.3.0


Version 0.7: 2008-04-21

	- print() now shows some information about a generator
	  object.

	- new function unuran.details() for printing detailed
	  information about a generator object. 

	- new function uqhinv() for compting quantiles approximately
	  using UNU.RAN method 'HINV'.


Version 0.6: 2007-12-10

	- added slots for a rectangular domain and the center 
	  (point in main region of distribution) for multivariate 
	  distribution class 'distr.cmv'.

	- new method 'MVTDR' in UNU.RAN.

	- fixed broken optional arguments in routines urtdr() and urhitro()
	  (The optional arguments were not passed to the given
	  density function in contradiction to the help page of
	  these routines.)


Version 0.5: 2007-08-01

	- added S4 classes for distribution objects:

	    This allows to define distributions by means of
	    R functions instead of using the UNU.RAN string API
	    (which is still supported).

	- added support for multivariate distributions.

	- added routine 'urtdr'.


Version 0.4: 2007-05-16

        - First public release.

	- new function unuran.new() for creating a UNU.RAN object.

	- new class "unuran.discr" for dicrete distributions.

	- new functions ur...() for sampling from various standard
	  distributions.

	- unuran.sample() is now a function and not an S4 method any more.

	- internal: added test suite for generation method.

	- internal: d fixed possible leak in R's PROTECT stack.


Version 0.3: 2007-05-03

        - added support for Windows.


Version 0.2: 2007-05-02

        - R CMD check now does not report any warnings or errors.


Version 0.1: 2007-04-30

        - First pre-alpha release.


